function SetCookie(cookieName,cookieValue,nDays) {
	var today = new Date();
	var expire = new Date();
	if (nDays==null || nDays==0) nDays=1;
	expire.setTime(today.getTime() + 3600000*24*nDays);
	document.cookie = cookieName+"="+escape(cookieValue)
	+ ";expires="+expire.toGMTString();
}

function ReadCookie(cookieName) {
	var theCookie=""+document.cookie;
	var ind=theCookie.indexOf(cookieName);
	if (ind==-1 || cookieName=="") return ""; 
	var ind1=theCookie.indexOf(';',ind);
	if (ind1==-1) ind1=theCookie.length; 
	return unescape(theCookie.substring(ind+cookieName.length+1,ind1));
}

function GetAJAXReply(url) {
	url += '?sid=' + (window.sessionid + '');
	
	var xmlHttp;
	xmlHttp=new XMLHttpRequest();

	xmlHttp.open("GET",url,false);
	xmlHttp.send(null);
	return xmlHttp.responseText;
}

function GetSessionId() {
	if(window.sessionid==0)
		window.sessionid = parseInt(GetAJAXReply("sessionid"));
}

function $(id) { return document.getElementById(id); }

window.camera = 1;
window.cameramax = parseInt(GetAJAXReply("cameranum"));
window.cameraname = "";
window.timestamp = "";
window.livestatus = "";
window.sessionid = 0;
window.live = 0;
window.inf = 365*30; // 30 years should be enough
window.inum = 100;

function LoadSettings() {
	var hiq = ReadCookie("highq");
	var fmt = ReadCookie("format");
	var osd = ReadCookie("showosd");
	if(hiq=="") { hiq = "0"; SetCookie("highq","0",inf); }
	if(fmt=="") { fmt = "1"; SetCookie("format","1",inf); }
	if(osd=="") { osd = "1"; SetCookie("showosd","1",inf); }

	$("s_imgformat").setAttribute("toggled",fmt=="0"?"false":"true");
	$("s_highq").setAttribute("toggled",hiq=="0"?"false":"true");
	$("s_showosd").setAttribute("toggled",osd=="0"?"false":"true");
}

function SaveSetting_t(name, ck) {
	var toggled = $(name).getAttribute("toggled");
	SetCookie(ck, toggled=="true"?"1":"0");
}

function SetNoImage() {
	$("liveimage").innerHTML = '<img src="noimage.png" id="cam" style="float: left;">';
}

function Previous() {
	window.camera--; if(window.camera<1) window.camera = window.cameramax;
	window.cameraname = GetAJAXReply("info/" + window.camera);
}
function Next() {
	window.camera++; if(window.camera>window.cameramax) window.camera = 1;
	window.cameraname = GetAJAXReply("info/" + window.camera);
}

function Play(speed) {
	switch(speed) {
		case -2: GetAJAXReply("view/play/rewind"); break;
		case -1: GetAJAXReply("view/play/stop");GetAJAXReply("view/play/rewind"); break;
		case  0: GetAJAXReply("view/play/stop"); break;
		case  1: GetAJAXReply("view/play/play"); break;
		case  2: GetAJAXReply("view/play/wind"); break;
	}
}

function StartLive() {
	if(window.live==1) return;
	window.live = 1;
	$("startbutton").setAttribute("onclick","StopLive()");
	$("startbutton").innerHTML = "Stop";
	window.cameraname = GetAJAXReply("info/" + window.camera);
	UpdateImage();
	UpdateTimestamp();
}

function StopLive() {
	if(window.live==0) return;
	window.live = 0;
	SetNoImage();
	$("startbutton").setAttribute("onclick","StartLive()");
	$("startbutton").innerHTML = "Start";
}

function UpdateCameras() {
	content = "";
	for(i=1;i<=window.cameramax;i++) {
		camname = GetAJAXReply("info/" + i);
		content += "<li><a href='#live' onclick='window.camera="+i+"; setTimeout(\"StartLive()\",400);'>" + camname + "</a></li>";
	}
	$("cameras").innerHTML = content;
}

function zeropad(str,n) {
	str = str + '';
	while(str.length<n) str = "0" + str;
	return str;
}

function UpdateTimestamp() {
	if(window.live==0) return;
	ts = GetAJAXReply("view/play/time");
	var tdata = ts.split(":");
	var d = new Date();
	d.setTime(parseInt(tdata[0]) * 1000);
	window.timestamp = zeropad(d.getFullYear(),4) + '-' + zeropad(d.getMonth()+1,2) + '-' + zeropad(d.getDate(),2)
		+ ' ' + zeropad(d.getHours(),2) + ':' + zeropad(d.getMinutes(),2) + ':' + zeropad(d.getSeconds(),2)
		+ '<span class="smaller">.' + zeropad(tdata[1],3) + '</span>';
	switch(tdata[2]) {
		case "0":
			window.livestatus = "Stop";
			break;
		case "live":
			window.livestatus = "Live";
			break;
		default:
			window.livestatus = tdata[2] + 'x';
	}
	setTimeout("UpdateTimestamp()", 200);
}

function UpdateImage() {
	if(window.live==0) return;
	hq = $("s_highq").getAttribute("toggled")=="true"?true:false;
	fmt = $("s_imgformat").getAttribute("toggled")=="true"?true:false;
	osd = $("s_showosd").getAttribute("toggled")=="true"?true:false;
	var imgname = "cam";
	if($(imgname).offsetWidth == 0) {StopLive();return;}
	if(!$(imgname).complete) {
		setTimeout("UpdateImage()", 40);
		return;
	}
	w = window.innerWidth; if(w>480) w = 480;
	h = w*3/4;
	/*if(h>(window.innerHeight-46)) {
		h = (window.innerHeight-46) / 16;
		h *= 16;
		w = h * 4 / 3;
	}*/
	w+='';h+='';
	$(imgname).src = "camera/" + window.camera
		+ "?width=" + w
		+ "&height=" + h
		+ "&quality=" + (hq?"90":"40")
		+ "&format=" + (fmt?"jpg":"png")
		+ "&sid=" + (window.sessionid+'')
		+ "&rand=" + (window.inum+'');
	window.inum++;
	
	if(osd)	{
		$("camnum").innerHTML = window.timestamp + '&nbsp;&nbsp;' + window.cameraname;
		$("camnum").style.display="inline";
		$("status").innerHTML = window.livestatus;
		$("status").style.display="inline";
	} else {
		$("camnum").style.display="none";
		$("status").style.display="none";
	}
	
	setTimeout("UpdateImage()", 100);
}
